*** empty log message ***
authorJim Meyering <jim@meyering.net>
Tue, 4 Mar 2003 19:49:35 +0000 (19:49 +0000)
committerJim Meyering <jim@meyering.net>
Tue, 4 Mar 2003 19:49:35 +0000 (19:49 +0000)
tests/rm/fail-2eperm [new file with mode: 0755]

diff --git a/tests/rm/fail-2eperm b/tests/rm/fail-2eperm
new file mode 100755 (executable)
index 0000000..d2a2002
--- /dev/null
@@ -0,0 +1,48 @@
+#!/bin/sh
+# Like fail-eperm, but the failure must be for a file encountered
+# while trying to remove the containing directory with the sticky bit set.
+
+if test "$VERBOSE" = yes; then
+  set -x
+  rm --version
+fi
+
+. $srcdir/../lang-default
+PRIV_CHECK_ARG=require-root . $srcdir/../priv-check
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+# Find a username with UID != 0.
+non_root_username=`grep -v '[^:]*:[^:]*:0:' /etc/passwd| sed -n '1s/:.*//p'`
+test "x$non_root_username" = x && framework_failure=1
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+# The containing directory must be owned by the user who eventually runs rm.
+chown $non_root_username .
+
+mkdir a || framework_failure=1
+chmod 1777 a || framework_failure=1
+touch a/b || framework_failure=1
+
+if test $framework_failure = 1; then
+  echo "$0: failure in testing framework" 1>&2
+  (exit 1); exit 1
+fi
+
+fail=0
+
+su -c 'rm -rf a' $non_root_username 2> out && fail=1
+cat <<\EOF > exp
+rm: cannot remove `a/b': Operation not permitted
+EOF
+
+cmp out exp || fail=1
+test $fail = 1 && diff out exp 2> /dev/null
+
+(exit $fail); exit $fail